/*----------------------------------------------------------------------------
 Copyright:      Jens Mundhenke
 Author:         Jens Mundhenke
 Remarks:		 Based on a webserver of Ulrich Radig
 known Problems:
 Version:        18.01.2009
 Description:    Bootloader main

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der
 GNU General Public License, wie von der Free Software Foundation verffentlicht,
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder
 (nach Ihrer Option) jeder spteren Version.

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung,
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE,
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 Programm erhalten haben.
 Falls nicht, schreiben Sie an die Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------------*/


#include <avr/io.h>
#include <math.h>
#include "config.h"
#include "para.h"
#if USE_CONSOLE
	#include "console.h"
#endif
#include "networkcard/enc28j60.h"
#include "networkcard/rtl8019.h"
#include "stack.h"
#include "timer.h"
#include "bootloader/tftp.h"
#include "bootloader/ihex.h"


//----------------------------------------------------------------------------
//Hier startet das Hauptprogramm
int main(void)
{
	ihex_intvector(IHEX_INTVECTOR_BOOT);

	//Applikationen starten
	stack_init();
	tftp_init();

	//Ethernetcard Interrupt enable
	ETH_INT_ENABLE;

	//Globale Interrupts einschalten
	sei();

	console_mode = (char)para_getip(TFTP_MSG_EEPROM_STORE, TFTP_MSGMSK);

	console_init();
	console_write("\n\rBoot\n\r");

	tftp_request();				// send tftp request for bootfile

    while(1)
	{
	    eth_get_data();			// handle timer and incoming packets
	    tftp_watchdogcheck();	// check for timeout in tftp communication
    }
}
